#ifndef _LCD_H_
#define _LCD_H_

#define OLDLCD	   

//16 Zeichen pro Zeile
#define LINECHARS16
//#define LINES        2
#define LINES          4

#ifdef LINECHARS16
#define LINECHARS     16
#endif
#ifndef LINECHARS16
#define LINECHARS     20
#endif

#define DATA	      0x00
#define INSTRUCTION   0x01

//Adr der Zeilen
#ifdef LINECHARS16
#define FIRST_LINE    0x80
#define SECOND_LINE   0xC0
#define THIRD_LINE    0x90
#define FOURTH_LINE   0xD0
#endif
#ifndef LINECHARS16
#define FIRST_LINE    0x80
#define SECOND_LINE   0xC0
#define THIRD_LINE    0x94
#define FOURTH_LINE   0xD4
#endif


//4 Bit
#define FUNCTION_SET  0x028


//Fkt. des Displays, Cursorfkt.
#define DISPLAY_CLEAR 0x01
#define DISPLAY_ON    0x0C
#define DISPLAY_OFF   0x08
#define CURSOR_ON     0x0E
#define CURSOR_OFF    0x0C
#define CURSOR_BLINK  0x0F
#define CURSOR_BLINK2 0x0D
#define CURSOR_RETURN 0x02
#define CURSOR_HOME	  0x02

//Rueckwaerts schreiben
#define ENTRY_MODE    0x04
//Vorwaerts schreiben
#define ENTRY_OFF     0x06

#define CURSOR_LEFT   0x10
#define CURSOR_RIGHT  0x14
//Schrift nach rechts schieben 
#define LINESHIFT_R   0x1C
#define LINESHIFT_L   0x18

#define CGRAM		  0x40
#define DDRAM	      0x80

//Grundinitialisierung
void lcd_init(void);
void lcd_enable(unsigned char uc_x);
void lcd_rs(unsigned char uc_x);
void lcd_Data_H(unsigned char uc_x);
void lcd_Data_L(unsigned char uc_x);

//Byteweise schreiben
void lcd_write(unsigned char uc_datentyp,unsigned char uc_x);

//eigene Zeichen 5x8 erzeugen
void lcd_createchar(unsigned char uc_adr,char * pc_pattern);

//Zeichen schreiben
void lcd_writechar(unsigned char uc_x,unsigned char uc_zeile,
                   unsigned char uc_offset);
				   
//Strings schreiben
void lcd_writestr(char * pc_str,unsigned char uc_zeile,unsigned char uc_offset);

//Display loeschen
void lcd_clear(void);

//Zeile loeschen
void lcd_lineclear(unsigned char uc_zeile);

//gehe mit Cursor an Position
void lcd_goto(unsigned char uc_x,unsigned char uc_y);
#endif
